#!/usr/bin/env python3

import secrets
import random
import matplotlib.pyplot as plt

def plot_csprng():
    n = 10000
    max_int = 100
    
    out = [0] * n
    for k in range(0, n):
        out[k] = secrets.randbelow(max_int)

    plt.hist(out)
    plt.show()

# -----------

def plot_prng():
    n = 10000
    max_int = 100
    
    out = [0] * n
    for k in range(0, n):
        out[k] = random.randint(0, max_int)

    plt.hist(out)
    plt.show()

# -----------

def main():
    figure, axis = plt.subplots(1, 2)

    n = 1000000
    max_int = 100

    csprng_out = [0] * n
    for k in range(0, n):
        csprng_out[k] = secrets.randbelow(max_int)

    prng_out = [0] * n
    for k in range(0, n):
        prng_out[k] = random.randrange(0, max_int)

    axis[0].hist(csprng_out, max_int, rwidth=0.5, color="red")
    axis[0].set_title("CSPRNG")
    
    axis[1].hist(prng_out, max_int, rwidth=0.5, color="blue")
    axis[1].set_title("PRNG")
    
    plt.show()
    
if __name__ == "__main__":
    main()
