#!/usr/bin/env python3

# Code used to show how to generate weird looking sequence of numbers
# that are completely deterministic and have nothing to do with
# randomness.
#
# Discussed in the following lecture:
# - https://teaching.leonardotamiano.xyz/cns/labs/lab_01_breaking_prng_part_1/
#
subway_B = [
    "laurentina", "EUR Fermi", "EUR Palasport", "EUR Magliana",
    "Marconi", "Basilica S. Paolo", "Garbatella", "Piramide",
    "Circo Massimo", "Colosseo", "Cavour", "Termini",
]

def station_to_number(station_name):
    result = 0
    for c in station_name:
        result = (result ^ ord(c)) + ord(c)
    return result

if __name__ == "__main__":
    for metro_station in subway_B:
        print(station_to_number(metro_station))
